"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var calendar_1 = require("@steroidsjs/core/utils/calendar");
var form_1 = require("@steroidsjs/core/ui/form");
var CalendarType_1 = __importDefault(require("@steroidsjs/core/ui/content/CalendarSystem/enums/CalendarType"));
require("./WeekHour.scss");
function WeekHour(props) {
    var bem = (0, useBem_1["default"])('WeekHour');
    var parentBem = props.parentBem;
    var _a = react_1["default"].useState(false), isExpanded = _a[0], setIsExpanded = _a[1];
    var events = react_1["default"].useMemo(function () {
        var callingDate = new Date(props.dayOfWeek.date);
        var timeArray = props.hour.replace(':', '').split('');
        callingDate.setHours(Number(timeArray[0] + timeArray[1]), 0, 0, 0);
        return props.getEventsFromDate(callingDate, CalendarType_1["default"].WEEK);
    }, [props]);
    var getFormattedExpandLabel = react_1["default"].useCallback(function () { return "".concat(__('Показать ещё'), " +").concat(events.length - 3); }, [events.length]);
    var hasOneEvent = events.length <= 1;
    var hasTwoEvents = events.length === 2;
    var hasTreeEvents = events.length >= 3;
    return (react_1["default"].createElement("div", { className: parentBem.element('hour', {
            isToday: props.dayOfWeek.isToday,
            hasOneEvent: hasOneEvent,
            hasTwoEvents: hasTwoEvents,
            hasTreeEvents: hasTreeEvents,
            isExpanded: isExpanded
        }) },
        events.map(function (event, eventIndex) { return (react_1["default"].createElement("div", { key: eventIndex, className: parentBem.element('hour-event'), style: { backgroundColor: event.color }, title: event.title },
            react_1["default"].createElement("span", { className: parentBem.element('hour-event-title') }, event.title),
            react_1["default"].createElement("span", { className: parentBem.element('hour-event-time') }, (0, calendar_1.convertDate)(event.date, null, 'HH:mm')))); }),
        hasTreeEvents && events.length > 3 && (react_1["default"].createElement(form_1.Button, { link: true, className: bem.element('expand-button') }, getFormattedExpandLabel()))));
}
exports["default"] = WeekHour;
